#ifndef RDTOKEN_H
#define RDTOKEN_H

class RdToken;
typedef int (RdToken::*RdTokenFuncPtr) ();


class RdToken {
	int token;
	char *text;
public:
	RdToken();
	char *getText() {return text;};
	void advance(int t);
	void advance();
	void error();
	int match(int t);
	void getFirst(RdTokenFuncPtr firsts, RdTokenFuncPtr follows, RdTokenFuncPtr augments);
	void getFollow(RdTokenFuncPtr follows, RdTokenFuncPtr augments);
	int inFirst_PROGRAM_ID_SEMICOLON_Block_PERIOD();
	int inFirst_AllDeclaration_CompoundStatement();
	int inFirst_Declarations_SubprogramDeclarations();
	int inFirst_VAR_IdentifierList_COLON_Type_SEMICOLON_Declarations();
	int inFirst_RD95EMPTY();
	int inFirst_ID_IdListTail();
	int inFirst_COMMA_ID_IdListTail();
	int inFirst_StandardType();
	int inFirst_ARRAY_LBRACK_INT95NUM_RANGE_INT95NUM_RBRACK_OF_StandardType();
	int inFirst_INTEGER();
	int inFirst_REAL();
	int inFirst_SubprogramDeclaration_SEMICOLON_SubprogramDeclarations();
	int inFirst_SubprogramHead_AllDeclaration_CompoundStatement();
	int inFirst_FUNCTION_ID_Arguments_COLON_StandardType_SEMICOLON();
	int inFirst_PROCEDURE_ID_Arguments_SEMICOLON();
	int inFirst_LPAREN_ParameterList_RPAREN();
	int inFirst_IdentifierList_COLON_Type_ParameterTail();
	int inFirst_SEMICOLON_IdentifierList_COLON_Type_ParameterTail();
	int inFirst_BEGIN95BLOCK_OptionalStatement_END95BLOCK();
	int inFirst_StatementList();
	int inFirst_Statement_StatementListTail();
	int inFirst_SEMICOLON_Statement_StatementListTail();
	int inFirst_ID_StatementOp();
	int inFirst_IfStatement();
	int inFirst_CompoundStatement();
	int inFirst_WhileStatement();
	int inFirst_ForStatement();
	int inFirst_ReadStatement();
	int inFirst_WriteStatement();
	int inFirst_WriteLnStatement();
	int inFirst_Index_OptionalAssign();
	int inFirst_ProcTail_OptionalAssign();
	int inFirst_AssignStatement();
	int inFirst_ASSIGN_Expression();
	int inFirst_WRITE_LPAREN_Expression_RPAREN();
	int inFirst_WRITELN_LPAREN_Expression_RPAREN();
	int inFirst_READ_LPAREN_IdRList_RPAREN();
	int inFirst_IdAccess_IdRTail();
	int inFirst_COMMA_IdAccess_IdRTail();
	int inFirst_LBRACK_IndexType_RBRACK();
	int inFirst_INT95NUM();
	int inFirst_ID();
	int inFirst_ID_IdAccessTail();
	int inFirst_Index();
	int inFirst_WHILE_Expression_DO_Statement();
	int inFirst_FOR_ID_AssignStatement_TO_Expression_DO_Statement();
	int inFirst_IF_Expression_THEN_Statement_Testelse();
	int inFirst_ELSE_Statement();
	int inFirst_SEMICOLON();
	int inFirst_LPAREN_ProcExpressionList_RPAREN();
	int inFirst_Expression_ProcExpressionListTail();
	int inFirst_COMMA_Expression_ProcExpressionListTail();
	int inFirst_SimpleExpression_ExpressionTail();
	int inFirst_RELOP_SimpleExpression();
	int inFirst_SIGN_Term_SimpleExpressionTail();
	int inFirst_Term_SimpleExpressionTail();
	int inFirst_ADDOP_Term_SimpleExpressionTail();
	int inFirst_Factor_TermTail();
	int inFirst_SIGN();
	int inFirst_MULOP_Sign_Factor_TermTail();
	int inFirst_ID_FactorOp();
	int inFirst_NOT_Factor();
	int inFirst_REAL95NUM();
	int inFirst_LPAREN_Expression_RPAREN();
	int inFirst_ProcTail();
	int inFirstProgram();
	int inFirstBlock();
	int inFirstAllDeclaration();
	int inFirstCompoundStatement();
	int inFirstDeclarations();
	int inFirstSubprogramDeclarations();
	int inFirstIdentifierList();
	int inFirstType();
	int inFirstIdListTail();
	int inFirstStandardType();
	int inFirstSubprogramDeclaration();
	int inFirstSubprogramHead();
	int inFirstArguments();
	int inFirstParameterList();
	int inFirstParameterTail();
	int inFirstOptionalStatement();
	int inFirstStatementList();
	int inFirstStatement();
	int inFirstStatementListTail();
	int inFirstStatementOp();
	int inFirstIfStatement();
	int inFirstWhileStatement();
	int inFirstForStatement();
	int inFirstReadStatement();
	int inFirstWriteStatement();
	int inFirstWriteLnStatement();
	int inFirstIndex();
	int inFirstOptionalAssign();
	int inFirstProcTail();
	int inFirstAssignStatement();
	int inFirstExpression();
	int inFirstIdRList();
	int inFirstIdAccess();
	int inFirstIdRTail();
	int inFirstIndexType();
	int inFirstIdAccessTail();
	int inFirstTestelse();
	int inFirstProcExpressionList();
	int inFirstProcExpressionListTail();
	int inFirstSimpleExpression();
	int inFirstExpressionTail();
	int inFirstTerm();
	int inFirstSimpleExpressionTail();
	int inFirstFactor();
	int inFirstTermTail();
	int inFirstSign();
	int inFirstFactorOp();
	int inFollowProgram();
	int inFollowBlock();
	int inFollowAllDeclaration();
	int inFollowCompoundStatement();
	int inFollowDeclarations();
	int inFollowSubprogramDeclarations();
	int inFollowIdentifierList();
	int inFollowType();
	int inFollowIdListTail();
	int inFollowStandardType();
	int inFollowSubprogramDeclaration();
	int inFollowSubprogramHead();
	int inFollowArguments();
	int inFollowParameterList();
	int inFollowParameterTail();
	int inFollowOptionalStatement();
	int inFollowStatementList();
	int inFollowStatement();
	int inFollowStatementListTail();
	int inFollowStatementOp();
	int inFollowIfStatement();
	int inFollowWhileStatement();
	int inFollowForStatement();
	int inFollowReadStatement();
	int inFollowWriteStatement();
	int inFollowWriteLnStatement();
	int inFollowIndex();
	int inFollowOptionalAssign();
	int inFollowProcTail();
	int inFollowAssignStatement();
	int inFollowExpression();
	int inFollowIdRList();
	int inFollowIdAccess();
	int inFollowIdRTail();
	int inFollowIndexType();
	int inFollowIdAccessTail();
	int inFollowTestelse();
	int inFollowProcExpressionList();
	int inFollowProcExpressionListTail();
	int inFollowSimpleExpression();
	int inFollowExpressionTail();
	int inFollowTerm();
	int inFollowSimpleExpressionTail();
	int inFollowFactor();
	int inFollowTermTail();
	int inFollowSign();
	int inFollowFactorOp();
	int inAugmentProgram();
	int inAugmentBlock();
	int inAugmentAllDeclaration();
	int inAugmentCompoundStatement();
	int inAugmentDeclarations();
	int inAugmentSubprogramDeclarations();
	int inAugmentIdentifierList();
	int inAugmentType();
	int inAugmentIdListTail();
	int inAugmentStandardType();
	int inAugmentSubprogramDeclaration();
	int inAugmentSubprogramHead();
	int inAugmentArguments();
	int inAugmentParameterList();
	int inAugmentParameterTail();
	int inAugmentOptionalStatement();
	int inAugmentStatementList();
	int inAugmentStatement();
	int inAugmentStatementListTail();
	int inAugmentStatementOp();
	int inAugmentIfStatement();
	int inAugmentWhileStatement();
	int inAugmentForStatement();
	int inAugmentReadStatement();
	int inAugmentWriteStatement();
	int inAugmentWriteLnStatement();
	int inAugmentIndex();
	int inAugmentOptionalAssign();
	int inAugmentProcTail();
	int inAugmentAssignStatement();
	int inAugmentExpression();
	int inAugmentIdRList();
	int inAugmentIdAccess();
	int inAugmentIdRTail();
	int inAugmentIndexType();
	int inAugmentIdAccessTail();
	int inAugmentTestelse();
	int inAugmentProcExpressionList();
	int inAugmentProcExpressionListTail();
	int inAugmentSimpleExpression();
	int inAugmentExpressionTail();
	int inAugmentTerm();
	int inAugmentSimpleExpressionTail();
	int inAugmentFactor();
	int inAugmentTermTail();
	int inAugmentSign();
	int inAugmentFactorOp();
};

#endif
